src/Otus.Teaching.Pcf.GivingToCustomer/Otus.Teaching.Pcf.GivingToCustomer.WebHost/Models/Requests/Preference/CreatePreferenceRequest.cs
namespace Otus.Teaching.Pcf.GivingToCustomer.WebHost.Models.Requests.Preference
{
    public class CreatePreferenceRequest
    {
        public string Name { get; set; }
    }
}

src/Otus.Teaching.Pcf.GivingToCustomer/Otus.Teaching.Pcf.GivingToCustomer.WebHost/Models/Requests/Preference/UpdatePreferenceRequest.cs
namespace Otus.Teaching.Pcf.GivingToCustomer.WebHost.Models.Requests.Preference
{
    public class UpdatePreferenceRequest : CreatePreferenceRequest
    {
    }
}

src/Otus.Teaching.Pcf.GivingToCustomer/Otus.Teaching.Pcf.GivingToCustomer.WebHost/Controllers/PreferencesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using AutoMapper;
using Microsoft.AspNetCore.Mvc;
using Otus.Teaching.Pcf.GivingToCustomer.Core.Abstractions.Repositories;
using Otus.Teaching.Pcf.GivingToCustomer.Core.Domain;
using Otus.Teaching.Pcf.GivingToCustomer.WebHost.Models.Requests.Preference;
using Otus.Teaching.Pcf.GivingToCustomer.WebHost.Models.Responses;

namespace Otus.Teaching.Pcf.GivingToCustomer.WebHost.Controllers
{
    /// <summary>
    /// Предпочтения клиентов
    /// </summary>
    public class PreferencesController : Controller
    {
        private readonly IRepository<Preference> _preferencesRepository;
        private readonly IMapper _mapper;

        public PreferencesController(IRepository<Preference> preferencesRepository, IMapper mapper)
        {
            _preferencesRepository = preferencesRepository;
            _mapper = mapper;
        }

        public ActionResult Create()
        {
            return View("Create");
        }

        [HttpPost]
        public async Task<ActionResult> Create(CreatePreferenceRequest request)
        {
            var preference = _mapper.Map<Preference>(request);
            await _preferencesRepository.AddAsync(preference);
            return RedirectToAction(nameof(Index));
        }

        public async Task<ActionResult<List<PreferenceResponse>>> Index()
        {
            var preferences = await _preferencesRepository.GetAllAsync();
            return View(preferences.Select(_mapper.Map<PreferenceResponse>));
        }

        public async Task<ActionResult<PreferenceResponse>> Details(Guid id)
        {
            var preference = await _preferencesRepository.GetByIdAsync(id);
            return View("Details", _mapper.Map<PreferenceResponse>(preference));
        }

        public async Task<ActionResult> Edit(Guid id)
        {
            var preference = await _preferencesRepository.GetByIdAsync(id);
            return View("Edit", _mapper.Map<UpdatePreferenceRequest>(preference));
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Edit(Guid id, UpdatePreferenceRequest request)
        {
            var preference = await _preferencesRepository.GetByIdAsync(id);
            _mapper.Map(request, preference);
            await _preferencesRepository.UpdateAsync(preference);
            return RedirectToAction(nameof(Index));
        }

        public async Task<ActionResult> Delete(Guid id)
        {
            var preference = await _preferencesRepository.GetByIdAsync(id);
            await _preferencesRepository.DeleteAsync(preference);
            return RedirectToAction(nameof(Index));
        }
    }
}

src/Otus.Teaching.Pcf.GivingToCustomer/Otus.Teaching.Pcf.GivingToCustomer.WebHost/Views/Preferences/Create.cshtml
@model Otus.Teaching.Pcf.GivingToCustomer.WebHost.Models.Requests.Preference.CreatePreferenceRequest

@{
    ViewData["Title"] = "Create";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1>Create</h1>

<h4>CreatePreferenceRequest</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

src/Otus.Teaching.Pcf.GivingToCustomer/Otus.Teaching.Pcf.GivingToCustomer.WebHost/Views/Preferences/Details.cshtml
@model Otus.Teaching.Pcf.GivingToCustomer.WebHost.Models.Responses.PreferenceResponse

@{
    ViewData["Title"] = "Details";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1>Details</h1>

<div>
    <h4>Preference</h4>
    <hr />
    <dl class="row">
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Id)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Id)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Name)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Name)
        </dd>
    </dl>
</div>
<div>
    @Html.ActionLink("Edit", "Edit", new { id = Model.Id }) |
    <a asp-controller="Preferences" asp-action="Index">Back to List</a>
</div>

src/Otus.Teaching.Pcf.GivingToCustomer/Otus.Teaching.Pcf.GivingToCustomer.WebHost/Views/Preferences/Edit.cshtml
@model Otus.Teaching.Pcf.GivingToCustomer.WebHost.Models.Requests.Preference.UpdatePreferenceRequest

@{
    ViewData["Title"] = "Edit";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1>Edit</h1>

<h4>UpdatePreferenceRequest</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Edit">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

src/Otus.Teaching.Pcf.GivingToCustomer/Otus.Teaching.Pcf.GivingToCustomer.WebHost/Views/Preferences/Index.cshtml
@model IEnumerable<Otus.Teaching.Pcf.GivingToCustomer.WebHost.Models.Responses.PreferenceResponse>

@{
    ViewData["Title"] = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1>Preferences</h1>

<p>
    <a asp-action="Create">Create New</a>
</p>

<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Id)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Name)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
@foreach (var item in Model) {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.Id)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Name)
            </td>
            <td>
                @Html.ActionLink("Edit", "Edit", new { id = item.Id }) |
                @Html.ActionLink("Details", "Details", new { id = item.Id }) |
                @Html.ActionLink("Delete", "Delete", new { id = item.Id })
            </td>
        </tr>
}
    </tbody>
</table>